import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * Mouse and remove them from the blood.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Cat extends Actor
{
    private int score;
    /**
     * Constructor for Cat
     */
    public Cat()
    {

    }
    /**
     * Act: move up and down when cursor keys are pressed.
     */
    public void act() 
    {
        checkKeyPress();
        checkCollision();
        checkYarn();
        checkMouseClick();
    }

    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY()-6);
        }
        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY()+6);
        }
        if (Greenfoot.isKeyDown("right")) 
        {
            setLocation( getX()+6, getY());
        }
        if (Greenfoot.isKeyDown("left")) 
        {
            setLocation( getX()-6, getY());
        }
    }

    private void checkCollision()
    {
        if(isTouching(Mouse.class))
        {
            removeTouching(Mouse.class);
            Greenfoot.playSound("Boom.wav");
            Sky Sky=(Sky)getWorld();
            Sky.addScore(30);
        }
        if(isTouching(Hammer.class))
        {
            removeTouching(Hammer.class);
            Sky Sky=(Sky)getWorld();
            Sky.addScore(-30);
            Greenfoot.playSound("Dan.wav");

        }
    }
    private void checkYarn()
    {
        Yarn yarn = (Yarn) getOneIntersectingObject(Yarn.class);

        if (yarn != null) {
            yarn.turn(9);
        }
    }

    private void checkMouseClick()
    {
        if (Greenfoot.mouseClicked(null)) 
        {
            turn(10);
        }
    }

}


