import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The Sky is the setting for our White Blood Cell scenario. 
 * It's a place where blood cells, bacteria and viruses float around.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Sky extends World
{
    private int score;
    private int time;
    /**
     * Constructor: Set up the staring objects.
     */
    public Sky()
    {    
        super(780, 360, 1); 
        prepare();
        setPaintOrder(Fire.class);
        score=0;
        showScore();
        time=1500;

    }

    /**
     * Create new floating objects at irregular intervals.
     */
    public void act()
    {
        showTime();
        showScore();
        countTime();
        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new Mouse(), 779, Greenfoot.getRandomNumber(360));
        }
        if (Greenfoot.getRandomNumber(100) < 5)
        {
            addObject(new DogCar(), 779, 330);
        }if (Greenfoot.getRandomNumber(100) < 5)
        {
            addObject(new DogCar(), 779, 20);
        }
        if (Greenfoot.getRandomNumber(100) < 2)
        {
            addObject(new Hammer(), 779, Greenfoot.getRandomNumber(359));
        }
        if (Greenfoot.getRandomNumber(100) < 4)
        {
            addObject(new Yarn(), 779, Greenfoot.getRandomNumber(359));
        }
    }

    public void addScore(int points)
    /**
     * Adds a score to the game
     */

    {
        score = score + points;
        showScore();
        if (score <0)
        {
            Greenfoot.stop();
            Greenfoot.playSound("game-over.wav");
        }
    }

    private void showScore()
    {
        showText("Score:"+score,690,65);

    }

    private void showTime()
    {
        showText("Time:"+time,690,85);
    }

    private void countTime()
    {
        time--;
        showTime();
        if(time == 0)
        {
            Greenfoot.stop();
            showEndMessage();
        }
    }

    private void showEndMessage()
    {
        showText("Time is up - you win!", 390, 150);
        showText("Your final score:" + score + "points",390,170);
    }

    
    /**
     * Prepare the world for the start of the program. In this case: Create
     * a white blood cell and the DogCar at the edge of the blood stream.
     */
    private void prepare()
    {
        Cat cat = new Cat();
        addObject(cat, 95, 179);
        DogCar DogCar = new DogCar();
        addObject(DogCar, 126, 1);
        DogCar DogCar2 = new DogCar();
        addObject(DogCar2, 342, 5);
        DogCar DogCar3 = new DogCar();
        addObject(DogCar3, 589, 2);
        DogCar DogCar4 = new DogCar();
        addObject(DogCar4, 695, 5);
        DogCar DogCar5 = new DogCar();
        addObject(DogCar5, 114, 320);
        DogCar DogCar6 = new DogCar();
        DogCar DogCar7 = new DogCar();
        addObject(DogCar7, 295, 320);
        DogCar DogCar8 = new DogCar();
        DogCar DogCar9 = new DogCar();
        DogCar DogCar10 = new DogCar();
        addObject(DogCar10, 480, 320);
        DogCar DogCar11 = new DogCar();
        addObject(DogCar11, 596, 320);
        DogCar DogCar12 = new DogCar();
        addObject(DogCar12, 740, 354);
        Fire fire=new Fire();
        addObject(fire, 0, 180);
        Fire fire2=new Fire();
        addObject(fire2, 770, 180);

        DogCar5.setLocation(126,326);
        DogCar6.setLocation(298,315);
        DogCar8.setLocation(634,309);
        DogCar7.setLocation(450,300);
        DogCar.setLocation(164,51);
        DogCar2.setLocation(350,49);
        DogCar3.setLocation(534,53);
        DogCar4.setLocation(704,49);
        DogCar.setLocation(159,38);
        DogCar2.setLocation(337,41);
        DogCar3.setLocation(516,33);
        DogCar4.setLocation(676,34);
        DogCar7.setLocation(458,309);
        DogCar7.setLocation(491,323);

        addObject(DogCar12,209,331);
        DogCar DogCar13 = new DogCar();
        addObject(DogCar13,246,320);
        DogCar DogCar14 = new DogCar();
        addObject(DogCar14,373,326);
        DogCar DogCar15 = new DogCar();
        addObject(DogCar15,665,337);
        DogCar DogCar16 = new DogCar();
        addObject(DogCar16,562,324);
        DogCar DogCar17 = new DogCar();
        addObject(DogCar17,595,18);
        DogCar DogCar18 = new DogCar();
        addObject(DogCar18,447,44);
        DogCar DogCar19 = new DogCar();
        addObject(DogCar19,289,45);
        DogCar DogCar20 = new DogCar();
        addObject(DogCar20,243,45);
        DogCar DogCar21 = new DogCar();
        addObject(DogCar21,93,46);
        fire2.setLocation(769,179);
        Fire fire3 = new Fire();
        addObject(fire3,746,138);
        Fire fire4 = new Fire();
        addObject(fire4,731,89);
        Fire fire5 = new Fire();
        addObject(fire5,727,24);
        Fire fire6 = new Fire();
        addObject(fire6,737,224);
        Fire fire7 = new Fire();
        addObject(fire7,738,302);
        Fire fire8 = new Fire();
        addObject(fire8,31,294);
        Fire fire9 = new Fire();
        addObject(fire9,35,254);
        Fire fire10 = new Fire();
        addObject(fire10,31,124);
        Fire fire11 = new Fire();
        addObject(fire11,21,31);
        fire11.setLocation(18,28);
        fire11.setLocation(30,103);
        fire11.setLocation(30,103);
        fire11.setLocation(30,103);
        fire11.setLocation(30,103);
        fire11.setLocation(30,103);
        fire11.setLocation(30,103);
        fire11.setLocation(30,103);
        fire11.setLocation(30,103);
        fire11.setLocation(30,103);
        fire11.setLocation(31,48);
        removeObject(fire11);

        fire.setLocation(25,189);
        Fire fire12 = new Fire();
        addObject(fire12,32,56);
        Fire fire13 = new Fire();
        addObject(fire13,713,86);
        Fire fire14 = new Fire();
        addObject(fire14,720,158);
        Fire fire15 = new Fire();
        addObject(fire15,717,219);
        Fire fire16 = new Fire();
        addObject(fire16,724,289);
        fire13.setLocation(712,67);
        fire14.setLocation(706,124);
        fire15.setLocation(713,172);
        fire16.setLocation(716,241);
    }
}
